[![iRODS](iRODS-Logo.png)](https://docs.irods.org)

[![Build Status](https://travis-ci.org/irods/irods.svg?branch=master)](https://travis-ci.org/irods/irods) [![Coverity Scan Build Status](https://scan.coverity.com/projects/2605/badge.svg)](https://scan.coverity.com/projects/2605) [![Issue Stats](http://issuestats.com/github/irods/irods/badge/pr?style=flat)](http://issuestats.com/github/irods/irods) [![Issue Stats](http://issuestats.com/github/irods/irods/badge/issue?style=flat)](http://issuestats.com/github/irods/irods)

The integrated Rule-Oriented Data System (iRODS) is open source data management software used by research organizations and government agencies worldwide.  iRODS is released as a production-level distribution aimed at deployment in mission critical environments.  It virtualizes data storage resources, so users can take control of their data, regardless of where and on what device the data is stored. As data volumes grow and data services become more complex, iRODS is serving an increasingly important role in data management.

The development infrastructure supports exhaustive testing on supported platforms; plugin support for microservices, storage resources, authentication mechanisms, new API endpoints, and databases; and extensive documentation, training, and support services.

- iRODS: [https://irods.org](https://irods.org)

- iRODS Consortium: [https://irods.org/consortium](https://irods.org/consortium)

- RENCI: [http://www.renci.org](http://www.renci.org)

## Benefits

- iRODS implements **data virtualization**, allowing access to distributed storage assets under a unified namespace, and freeing organizations from getting locked in to single-vendor storage solutions.
- iRODS enables **data discovery** using a metadata catalog that describes every file, every directory, and every storage resource in the iRODS Zone.
- iRODS automates **data workflows**, with a rule engine that permits any action to be initiated by any trigger on any server or client in the Zone.
- iRODS enables **secure collaboration**, so users only need to log in to their home Zone to access data hosted on a remote Zone.

## History

iRODS has a 20+ year history of funded projects.

Funders have included DARPA, NSF, DOD, DOE, LC, NARA, NASA, NOAA, USPTO, and LLNL.

[https://irods.org/about/history/](https://irods.org/about/history/)

## License

iRODS is released under a 3-clause BSD License.

## Links to elsewhere...

 - [https://github.com/irods](https://github.com/irods)
 - [https://docs.irods.org](https://docs.irods.org)
 - [https://twitter.com/irods](https://twitter.com/irods)

